#ifndef MONITOR2_H
#define MONITOR2_H

#include <systemc>
#include "debug_printer.h"

/**
 * All properties are a subclass of mon_property, and inherit all
 * virtual functions.
 */
class monitor2 : public mon_prototype {
 public:


  // The constructor
  monitor2(mon_observer* obs); 
  ~monitor2();
  
  virtual const char* to_string() const;
  virtual void callback_delta_cycle_end();
  void callback_received_inputs(int a, int b);
  void callback_sent_answer(int a);

 private: 
  mon_observer* observer;
  int num_complete_delta_cycles;
  int expected_result;
  int monitor_id;
};


#endif
